﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using Microsoft.WindowsAzure.Storage.Table;

namespace LoadController
{
    namespace TEST
    {
        public class Job : TableEntity
        {
            public Job()
                : base()
            {
            }

            public Job(string dllName, string classname, string methodname, string parameters, string invokeCount)
            {
                base.PartitionKey = "JOB";
                base.RowKey = (long.MaxValue - DateTime.Now.Ticks).ToString();
                this.DllName = dllName;
                this.ClassName = classname;
                this.MethodName = methodname;
                this.Parameters = parameters;
                this.InvokeCount = invokeCount;
            }

            public string DllName { get; set; }
            public string ClassName { get; set; }
            public string MethodName { get; set; }
            public string Parameters { get; set; }
            public string InvokeCount { get; set; }

            public string Name { get; set; }
            public string StartTime { get; set; }
            public string Duration { get; set; }
        }

        public class Sample : TableEntity
        {
            public Sample()
                : base()
            {
            }

            public Sample(string partitionKey, string type, string message)
            {
                base.PartitionKey = partitionKey;
                base.RowKey = (long.MaxValue - DateTime.Now.Ticks).ToString() + "_" + type;
                this.Type = type;
                this.Message = message;
            }

            public string Type { get; set; }
            public string Message { get; set; }
        }
    }
}